/**************************************************************/
/* This Module reads and writes files in the way Amsdos would */
/**************************************************************/

//#define DEBUG
#define STRICT
//#include <stdio.h>
//#include <stdlib.h>
#include <string.h>
//#include <ctype.h>
//#include "global.h"
#include "diskimg.h"
//#include "filen.h"
//#include "host.h"
#include "ams.h"
#include "amsp.h"
#include "amsstruc.h"
#include "wildcard.h"
#include "filexfer.h"
#include "filen.h"

//#include "xdpb.c"

#define DEBUG__
#define HEADER




//extern	DRIVE_DATA	DriveData[2];


/*===========================================================================*/
/* FILE FUNCTIONS - HIGH LEVEL */

/* Open a Amstrad file for reading or writing. */
void	Ams_OpenFile(CPC_FILEHANDLE *pCPCFileHandle, char *Filename, int Access)
{
AMS_FILESYSTEM_FILEHANDLE_DATA	*pFSFHData;
AMS_FILESYSTEM_DATA				*pFSData;

	pFSFHData = (AMS_FILESYSTEM_FILEHANDLE_DATA *)malloc(sizeof(AMS_FILESYSTEM_FILEHANDLE_DATA));
	pFSData = (AMS_FILESYSTEM_DATA *)pCPCFileHandle->pDriveData->pFSData;

	pCPCFileHandle->pFSFHData = pFSFHData;
	pCPCFileHandle->pFSData = pFSData;

	memset(pFSFHData, 0, sizeof(AMS_FILESYSTEM_FILEHANDLE_DATA));

	pFSFHData->pFileSystem = pFSData;
    pFSFHData->BlockListSize = (sizeof(int)*((pFSData->XDPBTotalBlocks)+2));
    pFSFHData->pBlockList = malloc(pFSFHData->BlockListSize);
	pFSFHData->pBlock = malloc(pFSData->XDPBBlockSize);
	pFSFHData->TotalBytes = 0;

	/* convert host filename to cpc representation - keep */
	HostFilenameToCPCFilename(Filename, pFSFHData->AmsFilename);

	if (Access==CPC_FILEHANDLE_READ)
	{
		/* Read directory - not really required?? */
		ReadDirectory(pFSData);

		/* Make block list for reading - blocks used by file */
		MakeBlockListRead(pFSData,Filename,0,pFSFHData->pBlockList,pFSFHData->BlockListSize);

		/* read the first block */
	    ReadBlock(pFSData,pFSFHData->pBlockList[pFSFHData->CurrentBlock],pFSFHData->pBlock);

		/* update block counter */
		pFSFHData->CurrentBlock++;

	}
	else
	{
		/* read directory so that it can be updated - cache directory */
		ReadDirectory(pFSData);

		/* update block bitmap which describes block status */
		UpdateBlockBitmap(pFSData);

		/* Make block list for writing - free blocks */
		MakeFreeBlockList(pFSData,pFSFHData->pBlockList,pFSFHData->BlockListSize);

		/* We want to write to the first block in the list */
		pFSFHData->CurrentBlock = 0;

		SetupDirEntry(pFSFHData,pFSFHData->CurrentBlock>>4);
	}

	/* Set position for character read/write in block */
	pFSFHData->BlockPosition=0;

	pFSFHData->DirIndex = 0;

	/*
#ifdef HEADER
	if (Access==CPC_FILEHANDLE_WRITE)
	{
		// we want to write a header... skip first 128 bytes

		for (i=0; i<128; i++)
		{
			Ams_PutChar(pCPCFileHandle,0);
		}
	}
#endif
*/
}

/* close an amstrad file. */
void	Ams_CloseFile(CPC_FILEHANDLE *pCPCFileHandle)
{
	if (pCPCFileHandle!=NULL)
	{
		AMS_FILESYSTEM_FILEHANDLE_DATA *pFSFHData = (AMS_FILESYSTEM_FILEHANDLE_DATA *)pCPCFileHandle->pFSFHData;
		AMS_FILESYSTEM_DATA *pFileSystem = pFSFHData->pFileSystem;


		/* If we writing, then we want to write last block, close the file,
		and update the directory */
		if (pCPCFileHandle->Access == CPC_FILEHANDLE_WRITE)
		{
			/* write last block */
			PutBlockAms(pFSFHData);

			/* write directory */
			WriteDirectory(pFileSystem);
		}

		if (pFSFHData!=NULL)
		{
			/* free memory allocated for block */
			if (pFSFHData->pBlock!=NULL)
				free(pFSFHData->pBlock);

			/* free memory allocated for block list */
			if (pFSFHData->pBlockList!=NULL)
				free(pFSFHData->pBlockList);
		}
	}
}

/* read a char from an opened amstrad file */
int	Ams_GetChar(CPC_FILEHANDLE *pCPCFileHandle)
{
int ch;
int BlockSize;
AMS_FILESYSTEM_FILEHANDLE_DATA *pFSFHData = (AMS_FILESYSTEM_FILEHANDLE_DATA *)pCPCFileHandle->pFSFHData;
AMS_FILESYSTEM_DATA *pFileSystem = pFSFHData->pFileSystem;

    BlockSize = pFileSystem->XDPBBlockSize;

	/* Check if we need to read next block */
	if (pFSFHData->BlockPosition>=BlockSize)
	{

		/* Get Block */
		if (ReadBlock(pFileSystem,pFSFHData->pBlockList[pFSFHData->CurrentBlock],pFSFHData->pBlock)!=TRUE)
			printf("Failed to read block %d!\r\n",pFSFHData->pBlockList[pFSFHData->CurrentBlock]);

		/* increment block counter */
		pFSFHData->CurrentBlock++;


		/* Increment Position */
		pFSFHData->BlockPosition=0;

	}

	/* get character from block */
	ch = pFSFHData->pBlock[pFSFHData->BlockPosition];

	/* increment character pointer */
	pFSFHData->BlockPosition++;

	/* return char */
	return ch;
}

/* get size of opened amstrad file */
 int	Ams_GetFileSize(CPC_FILEHANDLE *pCPCFileHandle)
{
int	i;
AMS_FILESYSTEM_FILEHANDLE_DATA *pFSFHData = (AMS_FILESYSTEM_FILEHANDLE_DATA *)pCPCFileHandle->pFSFHData;

	i=0;

	while (1==1)
	{
		if (pFSFHData->pBlockList[i]==0)
			break;

		i++;
	}

	/* i = no of blocks */

	return (i*pFSFHData->pFileSystem->XDPBBlockSize);
}

 /* write a char to an amstrad file */
void	Ams_PutChar(CPC_FILEHANDLE *pCPCFileHandle,int ch)
{
int BlockSize;
AMS_FILESYSTEM_FILEHANDLE_DATA *pFSFHData = (AMS_FILESYSTEM_FILEHANDLE_DATA *)pCPCFileHandle->pFSFHData;
AMS_FILESYSTEM_DATA	*pFileSystem = pFSFHData->pFileSystem;

    BlockSize = pFileSystem->XDPBBlockSize;

	pFSFHData->TotalBytes++;

	/* See if we need to write the block out */
	if (pFSFHData->BlockPosition>=BlockSize)
	{
		PutBlockAms(pFSFHData);

		/* Increment block counter */
		pFSFHData->CurrentBlock++;

		/* Set Position */
		pFSFHData->BlockPosition=0;
	}

	/* write data to block */
	pFSFHData->pBlock[pFSFHData->BlockPosition]=ch;

	/* Increment char position */
	pFSFHData->BlockPosition++;

	if (BytesPerBlockIndexInDirectory(pFileSystem)==1)
	{
		if ((pFSFHData->CurrentBlock>>4)!=pFSFHData->DirIndex)
		{
			/* if block index is in a position where a new dir entry is required,
			   create one */

			/* setup a new dir entry for this block */

			pFSFHData->DirIndex++;

			SetupDirEntry(pFSFHData,pFSFHData->DirIndex);
		}
	}
	else
	{
		if ((pFSFHData->CurrentBlock>>3)!=pFSFHData->DirIndex)
		{
			/* setup a new dir entry for this block */

			pFSFHData->DirIndex++;

			SetupDirEntry(pFSFHData,pFSFHData->DirIndex);
		}
	}
}

// rename a file on a cpc disc
void	Ams_RenameFile(AMS_FILESYSTEM_DATA *pFileSystem,int UserNo,char *pOldName, char *pNewName)
{
	int i;
	char	OldFilename[16];
	char	NewFilename[16];
	AMSDOSDIRENTRY	*pEntry;

	/* convert host filename to cpc filename */
	HostFilenameToCPCFilename(pOldName, OldFilename);

	/* convert host filename to cpc filename */
	HostFilenameToCPCFilename(pNewName, NewFilename);

	/* Read directory */
	ReadDirectory(pFileSystem);

	pEntry = (AMSDOSDIRENTRY *)pFileSystem->pCPCDirectory;

	for (i=0; i<pFileSystem->XDPBNumDirEntries+1; i++)
	{
		 /* Does this dir entry have the user index we want? */
	     if (pEntry->User == UserNo)
		 {
	 		char	CurrentFilename[16];

			 /* Get Filename in this dir entry */
            GetAmsFilename(CurrentFilename,pEntry);

			/* compare filenames */
            if (strcmp(CurrentFilename,OldFilename)==0)
            {
				/* filenames match */

				/* replace name in directory entry with new name */
				PutAmsFilename(NewFilename, pEntry);
			}
		 }

		 pEntry++;
	}

	/* Write directory */
	WriteDirectory(pFileSystem);
}

void	Ams_DeleteFile(AMS_FILESYSTEM_DATA *pFileSystem, int UserNo,char *pFilename)
{
	int i;
	char	Filename[16];
	AMSDOSDIRENTRY	*pEntry;

	/* convert host filename to cpc filename */
	HostFilenameToCPCFilename(pFilename, Filename);

	/* Read directory */
	ReadDirectory(pFileSystem);

	pEntry = (AMSDOSDIRENTRY *)pFileSystem->pCPCDirectory;

	for (i=0; i<pFileSystem->XDPBNumDirEntries+1; i++)
	{
		 /* Does this dir entry have the user index we want? */
	     if (pEntry->User == UserNo)
		 {
	 		char	CurrentFilename[16];

			 /* Get Filename in this dir entry */
            GetAmsFilename(CurrentFilename,pEntry);

			/* compare filenames */
            if (strcmp(CurrentFilename,Filename)==0)
            {
				/* filenames match */

				/* mark this directory entry as deleted */
				pEntry->User = 0x0e5;
			}
		 }

		 pEntry++;
	}

	/* Write directory */
	WriteDirectory(pFileSystem);
}

/*
int		Ams_GetFileSizeInK(AMS_FILESYSTEM_DATA *pFileSystem, char *Filename)
{
	int	i;
	AMSDOSDIRENTRY	*pEntry;

	int SizeOfFileInBlocks;

	SizeOfFileInBlocks	= 0;

	pEntry = (AMSDOSDIRENTRY *)pFileSystem->pCPCDirectory;

	for (i=0; i<pFileSystem->XDPBNumDirEntries+1; i++)
	{
		 // Does this dir entry have the user index we want?
			and is it the first directory entry for this file? //
	     if ((pEntry->User == UserNo) && (pEntry->DirEntry==0))
		 {
	 		char	CurrentFilename[16];

			 // Get Filename in this dir entry
            GetAmsFilename(CurrentFilename,pEntry);

			// compare filenames
            if (strcmp(CurrentFilename,Filename)==0)
            {
				// filenames match


				// mark this directory entry as deleted
				pEntry->User = 0x0e5;
			}
		 }

		 pEntry++;
	}
}
*/
/*
void	Ams_DisplayDirectory(AMS_FILESYSTEM_DATA *pFileSystem, char *FileSpec)
{
	int i;
	char	Filename[16];
	AMSDOSDIRENTRY	*pEntry;

	// convert host filename to cpc filename
	HostFilenameToCPCFilename(pFilename, Filename);

	// Read directory
	ReadDirectory(pFileSystem);

	pEntry = (AMSDOSDIRENTRY *)pFileSystem->pCPCDirectory;

	for (i=0; i<pFileSystem->XDPBNumDirEntries+1; i++)
	{
		 // Does this dir entry have the user index we want?
		//	and is it the first directory entry for this file?
	     if ((pEntry->User == UserNo) && (pEntry->DirEntry==0))
		 {
	 		char	CurrentFilename[16];

			 // Get Filename in this dir entry
            GetAmsFilename(CurrentFilename,pEntry);

			// compare filenames
            if (strcmp(CurrentFilename,Filename)==0)
            {
				// filenames match

				// mark this directory entry as deleted
				pEntry->User = 0x0e5;
			}
		 }

		 pEntry++;
	}
}
*/

/* check if file will fit on media */
BOOL	Ams_FileFit(DRIVE_DATA *pDriveData,int FileSize)
{
	AMS_FILESYSTEM_DATA *pFileSystem = (AMS_FILESYSTEM_DATA *)pDriveData->pFSData;

	if (
		(GetBlocksRequired(pFileSystem,FileSize)<=GetNumFreeBlocks(pFileSystem))
		&& (GetDirEntriesRequired(pFileSystem,FileSize)<=GetNumFreeDirEntries(pFileSystem)))
	{
		return TRUE;
	}

	return FALSE;
}

/*==========================================================================*/
/* BLOCK FUNCTIONS */

static int	BytesPerBlockIndexInDirectory(AMS_FILESYSTEM_DATA *pFileSystem)
{
//	DRIVE_DATA *pDriveData;

//	pDriveData = &DriveData[DriveNum];


	if (pFileSystem->XDPBTotalBlocks<256)
		return 1;
	else
		return 2;
}


/* return number of blocks required by this file for data */
int		GetBlocksRequired(AMS_FILESYSTEM_DATA *pFileSystem,int FileSize)
{
	int			NoOfBlocks;
	int			BlockSize;

//	DRIVE_DATA *pDriveData;

//	pDriveData = &DriveData[DriveNum];

	BlockSize = pFileSystem->XDPBBlockSize;

	NoOfBlocks = FileSize/BlockSize;

	if ((FileSize-(NoOfBlocks*BlockSize))!=0)
	{
		NoOfBlocks++;
	}

	return FileSize/pFileSystem->XDPBBlockSize;
}

/* return number of free blocks on disc */
int		GetNumFreeBlocks(AMS_FILESYSTEM_DATA *pFileSystem)
{
	int i;
	int	FreeBlockCount=0;

	/* read directory so that it can be updated */
	ReadDirectory(pFileSystem);

	/* update block bitmap which describes block status */
	UpdateBlockBitmap(pFileSystem);

	/* count number of unused blocks by looking at block bitmap */
	for (i=0; i<pFileSystem->BlockBitmapSize; i++)
	{
		if (pFileSystem->pBlockBitmap[i]==0x000)
		{
			FreeBlockCount++;
		}
	}

	/* return block count */
	return FreeBlockCount;
}

/* Read a block from media and put into buffer */
static int     ReadBlock(AMS_FILESYSTEM_DATA *pFileSystem,int BlockNumber,char *pData)
{
int i;
int SectorOffset;
SECTOR_POS SectorPos;
char *pDataPos;

    #ifdef DEBUG
    printf("Read Block: %d\n",BlockNumber);
    #endif


    pDataPos = pData;
    SectorOffset=BlockToSectorOffset(pFileSystem,BlockNumber);

    for (i=0; i<pFileSystem->XDPBSectorsPerBlock; i++)
    {
        SectorOffsetToSectorPos(pFileSystem,SectorOffset,&SectorPos);

		if (ReadSector(pFileSystem->pDriveData,&SectorPos,pDataPos,-1)==FALSE)
                return FALSE;

		pDataPos+=pFileSystem->XDPBSectorSize;
        SectorOffset++;
    }
    return TRUE;
}

/* Write a block to media from buffer */
static int     WriteBlock(AMS_FILESYSTEM_DATA *pFileSystem,int BlockNumber,char *pData)
{
int i;
int SectorOffset;
SECTOR_POS SectorPos;
char    *pDataPos;

#ifdef DEBUG__
	printf("AMS: Writing Block: %d\r\n",BlockNumber);
#endif


    pDataPos = pData;
    SectorOffset = BlockToSectorOffset(pFileSystem,BlockNumber);

    for (i=0; i<pFileSystem->XDPBSectorsPerBlock; i++)
    {
            SectorOffsetToSectorPos(pFileSystem,SectorOffset,&SectorPos);

			if (WriteSector(pFileSystem->pDriveData,&SectorPos,pDataPos,-1)==FALSE)
                    return FALSE;

			pDataPos+=pFileSystem->XDPBSectorSize;

            SectorOffset++;
    }
    return TRUE;
}

/*==========================================================================*/
/* SECTOR FUNCTIONS */

/* Read a sector of data from media */
static int     ReadSector(DRIVE_DATA *pDriveData, SECTOR_POS *pSectorPos, char *pData, int Length)
{
#ifdef DEBUG
//	printf("AMS: Reading sector: Drive %d Track %d Sector %x Side %d\r\n",pSectorPos->Drive,pSectorPos->Track,pSectorPos->Sector,pSectorPos->Side);
#endif

	switch (pDriveData->DriveType)
	{
		case DISK_IMAGE:
		{
			return DiskImage_GetSectorDsk(pDriveData->pDriveData,pSectorPos,pData, Length);
		}
		break;
		case REAL_DISK:
		{
/*            return GetSectorDisk(pSectorPos->Track,pSectorPos->Sector,pSectorPos->Side,pData);*/
		}
		break;
		case HOST_FILESYSTEM:
		{
			return FALSE;
		}
		break;
	}
	return TRUE;
}

/* Write a sector to the media */
static int     WriteSector(DRIVE_DATA *pDriveData,SECTOR_POS *pSectorPos, char *pData, int Length)
{
#ifdef DEBUG
//    printf("Writing sector: Drive %d Track %d Sector %x Side %d\r\n",pSectorPos->Drive,pSectorPos->Track,pSectorPos->Sector,pSectorPos->Side);
#endif

	switch (pDriveData->DriveType)
	{
		case DISK_IMAGE:
		{

			return DiskImage_PutSectorDsk(pDriveData->pDriveData,pSectorPos,pData, Length);
		}
		break;

		case REAL_DISK:
		{
	/*     return PutSectorDisk(pSectorPos->Track,pSectorPos->Sector,pSectorPos->Side,pData);*/
		}
		break;

		case HOST_FILESYSTEM:
		{
			return FALSE;
		}
		break;
	}
    return TRUE;
}

/*===========================================================================*/
/* DIRECTORY FUNCTIONS */

static int	GetNumFreeDirEntries(AMS_FILESYSTEM_DATA *pFileSystem)
{
	int	i;
	AMSDOSDIRENTRY	*pEntry;
	int FreeEntryCount = 0;

	/* get directory */
	ReadDirectory(pFileSystem);

	pEntry = (AMSDOSDIRENTRY *)pFileSystem->pCPCDirectory;

	/* count number of free entries (free entry is denoted by user
	being 0x0e5 */
	for (i=0; i<pFileSystem->XDPBNumDirEntries+1; i++)
	{
		if (pEntry->User==0x0e5)
		{
			FreeEntryCount++;
		}

		pEntry++;
	}

	return FreeEntryCount;
}

/* return number of directory entries required for this file */
static int	GetDirEntriesRequired(AMS_FILESYSTEM_DATA *pFileSystem,int FileSize)
{
	int NumBlocksRequired = GetBlocksRequired(pFileSystem,FileSize);

	int NumBlocksPerDirEntry = 16/BytesPerBlockIndexInDirectory(pFileSystem);

	return NumBlocksRequired/NumBlocksPerDirEntry;
}


/* Read Directory into buffer */
static int     ReadDirectory(AMS_FILESYSTEM_DATA *pFileSystem)
{
int     i;
char    *pData;

	pData=(char *)pFileSystem->pCPCDirectory;

    for (i=0; i<pFileSystem->XDPBNumDirBlocks; i++)
    {
            if (ReadBlock(pFileSystem,i,pData)==FALSE)
                    return FALSE;

            pData+=pFileSystem->XDPBBlockSize;
    }
    return TRUE;
}


/* Write Directory from buffer */
static int     WriteDirectory(AMS_FILESYSTEM_DATA *pFileSystem)
{
int     i;
char    *pData;

	pData=(char *)pFileSystem->pCPCDirectory;


    for (i=0; i<pFileSystem->XDPBNumDirBlocks; i++)
    {
            if (WriteBlock(pFileSystem,i,pData)==FALSE)
                    return FALSE;

            pData+=pFileSystem->XDPBBlockSize;
    }
    return TRUE;
}

/* Find free dir entry to add data to, NULL=DirectoryFull */
static AMSDOSDIRENTRY *GetFreeDirEntry(AMS_FILESYSTEM_DATA *pFileSystem)
{
int     i;
AMSDOSDIRENTRY  *pData;

    pData=(AMSDOSDIRENTRY *)pFileSystem->pCPCDirectory;

    for (i=0; i<pFileSystem->XDPBNumDirEntries+1; i++)
    {
        /* User of 0x0e5 indicates deleted entry or free entry */

        if (pData->User==0x0e5)
                return pData;
        pData++;
    }

    return NULL;
}

/* setup a directory entry */
static void	SetupDirEntry(AMS_FILESYSTEM_FILEHANDLE_DATA *pFh,int DirEntryNum)
{
	/* get a new dir entry */
	pFh->pDirEntry = GetFreeDirEntry(pFh->pFileSystem);

	if (pFh->pDirEntry!=NULL)
	{
		/* blank it out */
		memset(pFh->pDirEntry,0,sizeof(AMSDOSDIRENTRY));

		pFh->pDirEntry->DirEntryNum = DirEntryNum;

		/* Store amstrad version of filename into directory entry */
		PutAmsFilename(pFh->AmsFilename,pFh->pDirEntry);
	}
}

/* get a filename from a dir entry */
void    GetAmsFilename(char *Filename,AMSDOSDIRENTRY *pCPCDirectoryEntry)
{
int i;
    /* copy filename */

    memcpy(&Filename[0],pCPCDirectoryEntry->Filename,8);
    Filename[8]='.';
    memcpy(&Filename[9],pCPCDirectoryEntry->Extension,3);

    /* remove any bits which say about r/w etc */

    for (i=0; i<3; i++)
    {
           Filename[9+i] = (char)(Filename[9+i] & 0x07f);
    }
    Filename[12] = '\0';
}

/* put a Filename into a Dir entry */
static void		PutAmsFilename(char *Filename, AMSDOSDIRENTRY *pCPCDirectoryEntry)
{

	memcpy(pCPCDirectoryEntry->Filename,&Filename[0],8);
	memcpy(pCPCDirectoryEntry->Extension,&Filename[9],3);
}


/*===========================================================================*/
/* FILE SYSTEM STUFF */

/* Write a block of data back to the media, update the current directory entry */
static void	PutBlockAms(AMS_FILESYSTEM_FILEHANDLE_DATA *pFH)
{
int		NoOfRecords;
int		BlockIndex;
int		BlockCount;

	BlockIndex = pFH->pBlockList[pFH->CurrentBlock];

	/* Write Block */
	 if (WriteBlock(pFH->pFileSystem,BlockIndex,pFH->pBlock)!=TRUE)
		 printf("Failed to write block! %d\r\n",BlockIndex);

	BlockCount  = pFH->CurrentBlock;


	 if (BytesPerBlockIndexInDirectory(pFH->pFileSystem)==1)
	 {
		 int Index = BlockCount & 0x0f;

		 /* insert block number into directory entry */
		pFH->pDirEntry->Blocks[Index]	= BlockIndex;
	 }

	 if (BytesPerBlockIndexInDirectory(pFH->pFileSystem)==2)
	 {
		 /* insert block number into directory entry */

		 int Index = BlockCount & 0x07;

		 pFH->pDirEntry->Blocks[(Index<<1)] = BlockIndex & 0x0ff;
		 pFH->pDirEntry->Blocks[(Index<<1)+1] = (BlockIndex>>8) & 0x0ff;
	 }

	 /* calculate number of records for amount of data written */
	 NoOfRecords = pFH->BlockPosition>>7;

	 /* if remainder is !=0, then size written spans over part of another
	 block, include this extra block in the count */
	 if ((pFH->BlockPosition & 127)!=0)
		NoOfRecords++;

	 /* update record count */
	 pFH->pDirEntry->Records+=NoOfRecords;
}

/* Convert block number to sector offset which describes the number of
sectors to seek in to find start of block */
static int     BlockToSectorOffset(AMS_FILESYSTEM_DATA *pFileSystem,int BlockNum)
{
    return (BlockNum*pFileSystem->XDPBSectorsPerBlock);
}

/* Convert sector offset to track,sector and side describing location
   of sector on disc */
static void    SectorOffsetToSectorPos(AMS_FILESYSTEM_DATA *pFileSystem,int SectorOffset,SECTOR_POS *pSectorPos)
{
const XDPB *Xdpb;

    Xdpb = pFileSystem->Xdpb;

    /* check flag which indicates a double sided format. Note this
	flag doesn't actually exist in the XDPB structure. I put it in there. */
    if (Xdpb->ReservedSelectFormat!=1)
    {
            /* Normal disc format */

        //pSectorPos->Drive = DriveNum;
        pSectorPos->R=SectorOffset-((SectorOffset/Xdpb->SectorsPerTrack)*Xdpb->SectorsPerTrack)+Xdpb->FirstSectorNum;
        pSectorPos->Track=(SectorOffset/Xdpb->SectorsPerTrack)+((Xdpb->DirTrackHigh<<8)|(Xdpb->DirTrackLow));
        pSectorPos->Side=0;                     /* Temp */
    }
    else
    {
            /* Double sided disc formats */

		//	pSectorPos->Drive = DriveNum;
		 pSectorPos->R = SectorOffset-((SectorOffset/Xdpb->SectorsPerTrack)*Xdpb->SectorsPerTrack)+Xdpb->FirstSectorNum;
		 pSectorPos->Track = (SectorOffset/(Xdpb->SectorsPerTrack*2))+((Xdpb->DirTrackHigh<<8)||(Xdpb->DirTrackLow));

		 if (SectorOffset-(pSectorPos->Track*(Xdpb->SectorsPerTrack*2))>=(Xdpb->SectorsPerTrack))
		 {
			   pSectorPos->Side = 1;
		 }
		 else
		 {
				pSectorPos->Side = 0;
		 }
	}
}

/* updates a block bitmap. Each byte of the bitmap corresponds to a block
on the disc, if 1, then the block is used, if 0 then the block is free */
static void     UpdateBlockBitmap(AMS_FILESYSTEM_DATA *pFileSystem)
{
int i,j;
int Block;
AMSDOSDIRENTRY *pCPCDirectory;
char *pBlockBitmap;
int NoOfBytesInBlockIndex	= BytesPerBlockIndexInDirectory(pFileSystem);

	/* clear bitmap */
    memset(pFileSystem->pBlockBitmap,0x000,pFileSystem->BlockBitmapSize);

    pCPCDirectory = (AMSDOSDIRENTRY *)pFileSystem->pCPCDirectory;
    pBlockBitmap = (char *)pFileSystem->pBlockBitmap;

	/* go through each directory entry */
    for (i=0; i<pFileSystem->XDPBNumDirEntries; i++)
    {
        if (pCPCDirectory[i].User!=0x0e5)
        {
            /* Directory entry used. All blocks in the dir entry are used.
			Mark this in block bitmap */

			if (NoOfBytesInBlockIndex==1)
			{
				/* 1 byte for each block index */

				/* mark the bitmap that these blocks are used */
				for (j=0; j<16; j++)
                {
					   Block = pCPCDirectory[i].Blocks[j] & 0x0ff;

                       pBlockBitmap[Block] = -1;

                }
            }

			if (NoOfBytesInBlockIndex==2)
            {
				/* 2 Bytes for each block index */

				/* mark the bitmap that these blocks are used */
                for (j=0; j<8; j++)
                {
				   Block = (pCPCDirectory[i].Blocks[j*2] & 0x0ff) | ((pCPCDirectory[i].Blocks[(j*2)+1] & 0x0ff)<<8);

				   pBlockBitmap[Block] = -1;
                }
            }
        }
    }
}

/* make a ordered list of blocks that a file occupies for reading */
static void    MakeBlockListRead(AMS_FILESYSTEM_DATA *pFileSystem,char *Filename,int UserNo,int *pBlockList,int BlockListSize)
{
int     DirEntryBlock;
int     i,j;
char    AmstradFilename[16];
AMSDOSDIRENTRY *pEntry;
char	CPCFilename[16];
int	NoOfBytesInBlockIndex = BytesPerBlockIndexInDirectory(pFileSystem);

    pEntry= (AMSDOSDIRENTRY *)pFileSystem->pCPCDirectory;

	/* convert host filename to cpc filename */
    HostFilenameToCPCFilename(Filename, &CPCFilename[0]);

    /* Clear Block List */
    memset(pBlockList,0,BlockListSize);

    /* Get all blocks this file uses */

	/* go through each dir entry */
    for (i=0; i<pFileSystem->XDPBNumDirEntries+1; i++)
    {
		/* Is this dir entry used? And does it have the user number we want? */
      if ((pEntry->User == UserNo))
      {
		  /* Get Filename in this dir entry */
            GetAmsFilename(AmstradFilename,pEntry);

			/* compare filenames */
            if (strcmp(AmstradFilename,CPCFilename)==0)
            {
              /* Filename matches */

				/* These are blocks for the file. Copy blocks into our list
				at correct place. There is a directory entry index we can
				use to copy the blocks into the correct place. */

				DirEntryBlock = (pEntry->DirEntryNum & 0x0ff);

				if (NoOfBytesInBlockIndex==1)
				{
					/* one byte per block index */
				  for (j=0; j<16; j++)
				  {
					  int BlockIndex;

					  BlockIndex = pEntry->Blocks[j] & 0x0ff;

					  pBlockList[(DirEntryBlock<<4)+j] = BlockIndex;
				  }
				}

				if (NoOfBytesInBlockIndex==2)
				{
					/* two bytes per block index */
 					for (j=0; j<8; j++)
					{
						int BlockIndex;

						BlockIndex = (pEntry->Blocks[(j<<1)] & 0x0ff) | ((pEntry->Blocks[(j<<1)+1] & 0x0ff)<<8);

						pBlockList[(DirEntryBlock<<3)+j] = BlockIndex;
					}
	            }
            }
		  }

		pEntry++;
	}
}

/* Make a list of free blocks on the media. This list is used when writing
a file to the media. We make this list by checking the block bitmap */
static void    MakeFreeBlockList(AMS_FILESYSTEM_DATA *pFileSystem,int *pBlockList,int BlockListSize)
{
int     i,j;
char	*pBlockBitmap;

  pBlockBitmap = pFileSystem->pBlockBitmap;

	j=0;

	for (i=2; i<pFileSystem->XDPBTotalBlocks; i++)
	{
		/* Is block used ? */
		if (pBlockBitmap[i]==0x00)
		{
			/* No, store block number in our list */
			pBlockList[j] = i;
			j++;
		}
   }
	/* Finish List */

	pBlockList[j] = 0;
}




/*==========================================================================*/
/* DRIVE STUFF */


static int     SectorSizeTable[7]={128,256,512,1024,2048,4096,8192};

/* Return sector size from N value in sector ID */

static int     GetSectorSize(int N)
{
    if (N<8)
            return SectorSizeTable[N];
    else
            return 0x0200;
}

/* initialise access of amstrad media in a drive */
void	Ams_InitialiseDrive(DRIVE_DATA *pDriveData)
{
	AMS_FILESYSTEM_DATA *pFileSystem;

printf( "AMS initialise\n");

	pFileSystem = (AMS_FILESYSTEM_DATA *)malloc(sizeof(AMS_FILESYSTEM_DATA));

	if (pFileSystem!=NULL)
	{
		/* store file system pointer */
		pDriveData->pFSData = pFileSystem;

		/* get format of media */
		pFileSystem->pDriveData = pDriveData;
		pFileSystem->Xdpb = GetFormat(pDriveData);

        if (pFileSystem->Xdpb==NULL)
        {
            printf("Format not recognised for writing files to\n");
        }
        else
        {
            /* initialise for reading of this media */
            InitParams(pFileSystem);
        }
	}
}

/* finish accessing amstrad media in a drive */
void	Ams_FreeDrive(DRIVE_DATA *pDriveData)
{
	if (pDriveData->pFSData!=NULL)
	{
		AMS_FILESYSTEM_DATA *pFSData = pDriveData->pFSData;

		if (pFSData->pCPCDirectory!=NULL)
		{
			free(pFSData->pCPCDirectory);
		}

		if (pFSData->pBlockBitmap!=NULL)
		{
			free(pFSData->pBlockBitmap);
		}
	}
}



/* Initialise parameters required for reading blocks, sectors and files
from an Amstrad format. The Data comes from the XDPB which describes the
disc format */
static int    InitParams(AMS_FILESYSTEM_DATA *pFileSystem)
{
const XDPB    *Xdpb;

    Xdpb = pFileSystem->Xdpb;

    pFileSystem->XDPBSectorsPerBlock = ((Xdpb->RecordsPerBlock+1)/(Xdpb->RecordsPerSector));
    pFileSystem->XDPBNumDirEntries = (Xdpb->NumDirEntriesHigh<<8)|(Xdpb->NumDirEntriesLow);
    pFileSystem->XDPBSectorSize = GetSectorSize(Xdpb->SectorSizeN);
    pFileSystem->XDPBBlockSize = (Xdpb->RecordsPerBlock+1)<<7;
    pFileSystem->XDPBTotalBlocks = (Xdpb->TotalBlocksHigh<<8)|(Xdpb->TotalBlocksLow);
    pFileSystem->XDPBNumDirBlocks = ((pFileSystem->XDPBNumDirEntries+1)*sizeof(AMSDOSDIRENTRY))/pFileSystem->XDPBBlockSize;
	pFileSystem->RecordsPerBlock = Xdpb->RecordsPerBlock;

  pFileSystem->BlockBitmapSize = pFileSystem->XDPBTotalBlocks+1;

  if ((pFileSystem->pBlockBitmap = malloc(pFileSystem->BlockBitmapSize))==NULL)
  {
                return FALSE;
  }

  pFileSystem->CPCDirectorySize = pFileSystem->XDPBNumDirBlocks*pFileSystem->XDPBBlockSize;

  if ((pFileSystem->pCPCDirectory = malloc(pFileSystem->CPCDirectorySize))==NULL)
  {
           return FALSE;
  }

        return TRUE;
}

static const XDPB    *GetFormat(DRIVE_DATA *pDriveData)
{
FORMAT_DATA FormatData;
int     i;

        switch (pDriveData->DriveType)
        {
            case    DISK_IMAGE:
            {
					DiskImage_GetFormatDsk(pDriveData->pDriveData,&FormatData);
                    break;
            }
            case    REAL_DISK:
            {
                    /*GetFormatDisk(&DriveData[DriveNum],&FormatData);*/
                    break;
            }
        }
        const FORMAT_INFO *pFormatsRecognised = GetFormatsRecognised();
        for (i=0; i<GetNumFormatsRecognised(); i++)
        {
            const FORMAT_INFO *pSourceFormatInfo = &pFormatsRecognised[i];
            const FORMAT_DATA *pSourceFormatData = pSourceFormatInfo->pFormatData;
            if (memcmp(pSourceFormatData,&FormatData,sizeof(FORMAT_DATA))==0)
            {
              //      #ifdef DEBUG
				printf("AMS: Format found: %s\n",pSourceFormatInfo->pFormatName);
                //    #endif
                    return pSourceFormatInfo->pFormatXdpb;
            }
        }

//        #ifdef DEBUG
        printf("Not recognised format\n");
  //      #endif
        return 0;
}



/*===========================================================================*/
/* FILE HEADER STUFF */
/*
generate a checksum for the header passed. This can be used to create a
header or verify if one already exists.
*/
int		GenerateChecksumForAmsdosHeader(AMSDOSFILEHEADER *pHeader)
{
	int	i;
	int Checksum = 0;
	char *pData = (char *)pHeader;

	for (i=0; i<67; i++)
	{
		Checksum+=(pData[i] & 0x0ff);
	}

	return Checksum & 0x0ffff;
}

/*

  Create a Amsdos header.

pHeader = pointer to data area to fill in with buffer details.

 */
void	CreateAmsdosHeader(AMSDOSFILEHEADER *pHeader, char *Filename, int FileLength)
{
	int Checksum;

	/* clear header */
	memset((char *)pHeader,0,sizeof(AMSDOSFILEHEADER));

	memcpy(pHeader->Filename,Filename,8);
	memcpy(pHeader->Extension,&Filename[9],3);

	/* binary file */
	pHeader->FileType = 2;

	/* set file size */
	pHeader->TotalFileLengthLow = FileLength & 0x0ff;
	pHeader->TotalFileLengthMid = (FileLength>>8) & 0x0ff;
	pHeader->TotalFileLengthHigh = (FileLength>>16) & 0x0ff;

	pHeader->FileLengthLow = pHeader->TotalFileLengthLow;
	pHeader->FileLengthHigh = pHeader->TotalFileLengthMid;

	/* generate a checksum for header and write it in */
	Checksum = GenerateChecksumForAmsdosHeader(pHeader);

	pHeader->ChecksumLow = Checksum & 0x0ff;
	pHeader->ChecksumHigh = (Checksum>>8) & 0x0ff;
}


#include "wildcard.h"
#include "namelist.h"

/* generate a list of filenames that match the filespec */
void	Ams_GenerateFileList(AMS_FILESYSTEM_DATA *pFileSystem, char *FileSpec, NAME_LIST_HEADER *pNameList)
{
	int i;
	AMSDOSDIRENTRY	*pEntry;

	/* read directory */
	ReadDirectory(pFileSystem);

	pEntry = (AMSDOSDIRENTRY *)pFileSystem->pCPCDirectory;

	/* go through each dir entry and if filename matches store it */
	for (i=0; i<pFileSystem->XDPBNumDirEntries+1; i++)
	{
		if (pEntry->User!=0x0e5)
		{
			/* not a deleted entry */

	 		char	CurrentFilename[16];

			/* first dir entry for this file? */
			if (pEntry->DirEntryNum==0)
			{

				/* Get Filename in this dir entry */
				GetAmsFilename(CurrentFilename,pEntry);

				if (WildCard_Match(CurrentFilename,FileSpec))
				{
					NameList_AddName(pNameList,CurrentFilename);
				}
			}
		}

		pEntry++;
	}
}
