#ifndef __AMS_PRIVATE_INCLUDED__
#define __AMS_PRIVATE_INCLUDED__

#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "amsstruc.h"
#include "dskimgs.h"
#include "filexfer.h"

/* function protos */

/* Directory operations */

static int     ReadDirectory(AMS_FILESYSTEM_DATA *);
static int     WriteDirectory(AMS_FILESYSTEM_DATA *);
static void	UpdateBlockBitmap(AMS_FILESYSTEM_DATA *);

//static void	GetAmsFilename(char *,AMSDOSDIRENTRY *);
static void	PutAmsFilename(char *,AMSDOSDIRENTRY *);


/* Block operations */
static int     ReadBlock(AMS_FILESYSTEM_DATA *,int,char *);
static int     WriteBlock(AMS_FILESYSTEM_DATA *,int,char *);

static int     GetSectorSize(int);
static int     BlockToSectorOffset(AMS_FILESYSTEM_DATA *,int);
static void    SectorOffsetToSectorPos(AMS_FILESYSTEM_DATA *,int,SECTOR_POS *);

static void	UpdateBlockBitmap(AMS_FILESYSTEM_DATA *);
static AMSDOSDIRENTRY *GetFreeDirEntry(AMS_FILESYSTEM_DATA *);


static void    MakeBlockListRead(AMS_FILESYSTEM_DATA *,char *,int,int *,int);
static void	MakeFreeBlockList(AMS_FILESYSTEM_DATA *,int *,int);

static void	PutBlockAms(AMS_FILESYSTEM_FILEHANDLE_DATA *pCPCFileHandle);
static void	SetupDirEntry(AMS_FILESYSTEM_FILEHANDLE_DATA *pCPCFileHandle, int DirEntryNum);

/* sector routines */
static int     ReadSector(DRIVE_DATA *, SECTOR_POS *pSectorPos, char *pData, int Length);
static int     WriteSector(DRIVE_DATA *,SECTOR_POS *pSectorPos, char *pData, int Length);

static int	BytesPerBlockIndexInDirectory(AMS_FILESYSTEM_DATA *pFileSystem);

/* get number of free blocks */
static int				GetNumFreeBlocks(AMS_FILESYSTEM_DATA *pFileSystem);

/* get number of free directory entries */
static int				GetNumFreeDirEntries(AMS_FILESYSTEM_DATA *pFileSystem);

/* return number of dir entries required by a particular sized file */
static int				GetDirEntriesRequired(AMS_FILESYSTEM_DATA *pFileSystem,int FileSize);

/* return number of blocks required by a particular sized file */
static int				GetBlocksRequired(AMS_FILESYSTEM_DATA *,int FileSize);



/* --- Drive operations --- */

#include "global.h"

/* setup file system parameters */
static int    InitParams(AMS_FILESYSTEM_DATA *);
static const XDPB		*GetFormat(DRIVE_DATA *);

static void    GetAmsFilename(char *Filename,AMSDOSDIRENTRY *pCPCDirectoryEntry);


#endif
