#ifndef __DSK_STRUCTS_INCLUDED__
#define __DSK_STRUCTS_INCLUDED__

/* standard disc image structures */

typedef struct	DSKCHRN
{
	unsigned char	C;
	unsigned char	H;
	unsigned char	R;
	unsigned char	N;
	unsigned char	ST1;
	unsigned char	ST2;
	unsigned char	pad0;
	unsigned char	pad1;
} DSKCHRN;

typedef struct	DSKTRACKHEADER
{
	char	TrackHeader[12];
	char	pad0[4];
	unsigned char	track;
	unsigned char	side;
	unsigned char	pad1[2];
	unsigned char	BPS;
	unsigned char	SPT;
	unsigned char	Gap3;
	unsigned char	FillerByte;
	DSKCHRN	SectorIDs[29];
} DSKTRACKHEADER;

typedef struct DSKHEADER
{
	char		DskHeader[34];
	char		DskCreator[14];
	unsigned char	NumTracks;
	unsigned char	NumSides;
	unsigned char	TrackSizeLow;
	unsigned char	TrackSizeHigh;
	char		pad0[255-4-14-33];
} DSKHEADER;

/* extended disc image structures */

typedef struct	EXTDSKCHRN
{
	unsigned char	C;
	unsigned char	H;
	unsigned char	R;
	unsigned char	N;
	unsigned char	ST1;
	unsigned char	ST2;
	unsigned char	SectorSizeLow;
	unsigned char	SectorSizeHigh;
} EXTDSKCHRN;

typedef struct	EXTDSKTRACKHEADER
{
	char	TrackHeader[12];
	char	pad0[4];
	unsigned char	track;
	unsigned char	side;
	unsigned char	pad1[2];
	unsigned char	BPS;
	unsigned char	SPT;
	unsigned char	Gap3;
	unsigned char	FillerByte;
	EXTDSKCHRN	SectorIDs[29];
} EXTDSKTRACKHEADER;

typedef struct EXTDSKHEADER
{
	char		DskHeader[34];
	char		DskCreator[14];
	unsigned char	NumTracks;
	unsigned char	NumSides;
	unsigned char	TrackSizeLow;
	unsigned char	TrackSizeHigh;
	char		TrackSizeTable[255-4-14-33];
} EXTDSKHEADER;

#endif
