#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include "namelist.h"

/* Create a new list to hold a list of strings */
NAME_LIST_HEADER	*NameList_Create()
{
	NAME_LIST_HEADER	*pList;

	pList = (NAME_LIST_HEADER *)malloc(sizeof(NAME_LIST_HEADER));

	if (pList!=NULL)
	{
		pList->NoOfNames = 0;
		pList->pFirstEntry = NULL;
		pList->pLastEntry = NULL;
	}

	return pList;
}

/* delete a list of strings */
void	NameList_Delete(NAME_LIST_HEADER *pList)
{
	NAME_LIST_ENTRY	*pEntry;

	pEntry = pList->pFirstEntry;

	if (pEntry!=NULL)
	{
		NAME_LIST_ENTRY	*pNextEntry;

		do
		{

			if (pEntry->Name!=NULL)
				free(pEntry->Name);

			pNextEntry = pEntry->pNextEntry;

			free(pEntry);

			pEntry = pNextEntry;
		}
		while (pEntry!=NULL);
	}
}

/* Add a string to the list */
void	NameList_AddName(NAME_LIST_HEADER *pList, char *Name)
{
	NAME_LIST_ENTRY *pEntry;

	if ((pList!=NULL) && (Name!=NULL))
	{
		/* create a new entry */
		pEntry = (NAME_LIST_ENTRY *)malloc(sizeof(NAME_LIST_ENTRY));

		if (pEntry!=NULL)
		{
			int	NameLength = strlen(Name)+1;

			/* setup entry */
			pEntry->Name = (char *)malloc(NameLength);

			if (pEntry->Name!=NULL)
			{
				memcpy(pEntry->Name,Name,NameLength);
			}

			pEntry->pNextEntry = NULL;

			/* Add entry to list */
			if ((pList->pFirstEntry==NULL) && (pList->pLastEntry==NULL))
			{
				/* list is empty, insert at start */
				pList->pFirstEntry = pEntry;
				pList->pLastEntry = pEntry;
				pList->NoOfNames = 1;
			}
			else
			{
				/* list has items, add at end of list */
				pList->pLastEntry->pNextEntry = pEntry;
				pList->pLastEntry = pEntry;
				pList->NoOfNames++;
			}
		}
	}
}
